<?
require_once "../lib/dbinit.php";
require_once "../lib/msg.php";

class Notice {
    function Notice() {
    }

    /* override this in subclasses */
    function notify() {
    }

    /* emailNotify()
     * @access private
     * gets list of users who want the email, and then sends the emails out.
     * gets called by the subclassed implementation of notify()
     *
     * If you do NOT want the From: line to be from a user, make $authorUsername
     * be an empty string, then give something for $emailFrom.
     *
     * msg_id, marea_id will be metainfo in the email, required for
     * reply-ability.
     *
     */
    function emailNotify($authorUsername, $subj, $msg, $msg_id=0, $marea_id=0,
                         $emailFrom="") {
        global $CURGROUP;
        
        require_once "../lib/Emailer.php";
        $e = new Emailer;

        $metadb = dbinit_meta_connect();

        //currently works with DemeAuth using the DB storage class
        //needs to change if you're using non-pod user db

        $db = $CURGROUP->getDB();
        $metadb = dbinit_meta_connect();

        $res = $db->query("SELECT username FROM users 
                            WHERE wants_email_posts = 1");
        $quoted_usernames = array();
        while($row = $res->fetchRow()) {
            $quoted_usernames[] = "'" .addslashes($row['username']) ."'";
        }

        $rows = Array();
        if($quoted_usernames) {
            $usernames_sql = "(" .implode(",", $quoted_usernames). ")";

            $res = $metadb->query(
                        "SELECT firstname,lastname,email FROM users
                            WHERE username IN $usernames_sql
                            AND email != \"\"");
            while($row = $res->fetchRow()) {
                $rows[] = $row;
            }
        }
        $nonuser_subscribers = $db->getAll("SELECT email FROM nonuser_subscribers");
        $e->setRecipientsFromRows($rows);
        $e->setNonuserRecipientsFromRows($nonuser_subscribers);

        //Options for setting the From: line
        if($authorUsername) {
            $e->setFromByUser($metadb, $authorUsername);
        } else if($emailFrom) {
            $e->setFrom($emailFrom);
        } else {
            $e->setFrom("Deme Notifier <no_reply@groupspace.org>");
        }

        $e->setSubject($subj);
        $e->setTextMessage($msg);
        $e->setMsgId($msg_id);
        $e->setMareaId($marea_id);
        $db = $CURGROUP->getDB();
        $e->setMareaName($db->getOne("SELECT short_name FROM mareas WHERE marea_id = $marea_id"));
        $e->setGroupName($CURGROUP->getName());
        $e->setGroupUrl($CURGROUP->getTopUrl());
        $e->send();
    }

    /* Add new notification methods here -
     * AIMNotify(), IRCNotify(), Jabber, rss, or whatever
     */

    
//     /* _logForDigest() - DEPRECATED
//      * @access private
//      */
//     function _logForDigest($logname, $logentry) {
//         $dailylog = fopen($CURGROUP->getDataDir()."/log/daily/$logname", 'a');
//         $weeklylog =fopen($CURGROUP->getDataDir()."/log/weekly/$logname", 'a');
//         $line = $logentry . "\n";
//         fwrite($dailylog, $line);
//         fwrite($weeklylog, $line);
//         fclose($dailylog);
//         fclose($weeklylog);
//     }

        
}

class MessageNotice extends Notice {
    function MessageNotice($authorUsername, $msg_id, $marea_id,
                           $subj, $emailMsg) {
        $this->authorUsername = $authorUsername;
        $this->msg_id = $msg_id;
        $this->marea_id = $marea_id;
        $this->subj = $subj;
        $this->emailMsg = $emailMsg;
    }
    
    function notify() {
//        $emailSubj = "$this->authorUsername: \"$this->subj\"";
        $emailSubj = $this->subj;
        $emailMsg = $this->emailMsg;
        
        $this->emailNotify($this->authorUsername, $emailSubj, $emailMsg,
                           $this->msg_id, $this->marea_id);
    }
}


class DocumentNotice extends Notice {
    function DocumentNotice(&$doc, $db) {
        $this->doc = $doc;
        $q = "SELECT long_name FROM mareas
              WHERE marea_id = $doc->marea_id";
        $this->marea_name = $db->getOne($q);
        $this->marea_id = $doc->marea_id;
    }

    function notify() {
        global $CURGROUP;
        $emailFrom = "";
        $emailSubj  = "New Document: \"".$this->doc->title."\"";
//        $emailSubj .= " by ".$this->doc->orig_author;
        $emsg = $this->doc->display_tag . ". " . $this->doc->title . "\n\n";
        $emsg .= $this->doc->preface_text . "\n\n";
        $emsg .= "This new document posted by " . $this->doc->orig_author;
        $emsg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $emsg .= "View it at:  ";
        $emsg .= "  ".$CURGROUP->getUrlRoot()."/marea/?";
        $emsg .= "marea_id=".$this->doc->marea_id;
        $emsg .= "&msg_id=".$this->doc->orig_preface_msg_id;
        $this->emailNotify( $this->doc->orig_author, $emailSubj, $emsg,
                            $this->doc->orig_preface_msg_id, $this->marea_id);
    }
}

/**********************
class DiscoItemNotice extends Notice {
    function DiscoItemNotice($db,$marea_id,$title,$preface,$author,$msg_id) {
        $this->msg_id = $msg_id;
        $this->marea_name = $db->getOne("SELECT long_name FROM mareas WHERE
            marea_id = $marea_id");
        $this->author = $author;
        $this->title = $title;
	$this->preface = $preface;
        $this->marea_id = $marea_id;
    }

    function notify() {
        global $CURGROUP;
        $emailFrom = "";
        $emailSubj  = "New discussion item \"".$this->title."\"";
        $emailSubj .= " by ".$this->author;
        
	$msg = $this->title . "\n\n";
	$msg .= $this->preface . "\n\n";
        $msg .= "This new discussion item posted by " . $this->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";

        $msg .= "View it at: ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->marea_id;
        $msg .= "&msg_id=".$this->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}*************************/

class DiscoItemNotice extends Notice {
  function DiscoItemNotice($db, $discoitem) {
    $this->discoitem = $discoitem;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas 
                              WHERE marea_id = $discoitem->marea_id");
  }

  function notify() {
        global $CURGROUP;
        $emailSubj  = "New Discussion Item: \"".$this->discoitem->title."\"";
//        $emailSubj .= " by ".$this->discoitem->author;
        
        $msg = /*$this->discoitem->displaytag .*/ "New discussion item: " . $this->discoitem->title . "\n\n";
        $msg .= $this->discoitem->preface_text . "\n\n";
        $msg .= "This new discussion item posted by " . $this->discoitem->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";

        $msg .= "View it at: ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->discoitem->marea_id;
        $msg .= "&msg_id=".$this->discoitem->msg_id;
        $this->emailNotify( $this->discoitem->author, $emailSubj, $msg,
                            $this->discoitem->msg_id,
                            $this->discoitem->marea_id);
    }
}

class ProjectNotice extends Notice {
  function ProjectNotice($db, $project) {
    $this->project = $project;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas 
                              WHERE marea_id = $project->marea_id");
  }

  function notify() {
        global $CURGROUP;
        $emailSubj  = "New Project: \"".$this->project->title."\"";
//        $emailSubj .= " by ".$this->project->author;
        
        $msg = /*$this->project->displaytag .*/ "New project: " . $this->project->title . "\n\n";
        $msg .= $this->project->preface_text . "\n\n";
        $msg .= "This new project was posted by " . $this->project->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";

        $msg .= "View it at: ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->project->marea_id;
        $msg .= "&msg_id=".$this->project->msg_id;
        $this->emailNotify( $this->project->author, $emailSubj, $msg,
                            $this->project->msg_id,
                            $this->project->marea_id);
    }
}

class TaskNotice extends Notice {
  function TaskNotice($db, $task) {
    $this->task = $task;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas 
                              WHERE marea_id = $task->marea_id");
  }
 function notifyUpdate($new_history, $name) {
        global $CURGROUP;
        $emailSubj  = "Task Updated: \"".$this->task->title."\"";
//        $emailSubj .= " by ".$name;
        
        $msg = /*$this->task->displaytag .*/ "Task Update: " . $this->task->title . "\n\n";
        $msg .= $this->task->preface_text . "\n\n";
        $msg .= "This task was updated by " . $name;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $msg .= $new_history;
        $msg .= "\n\nView it at: ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->task->marea_id;
        $msg .= "&msg_id=".$this->task->msg_id;
        $this->emailNotify( $name, $emailSubj, $msg,
                            $this->task->msg_id,
                            $this->task->marea_id);
 }
  function notify() {
        global $CURGROUP;
        $emailSubj  = "New Task: \"".$this->task->title."\"";
//        $emailSubj .= " by ".$this->task->author;
        
        $msg = /*$this->task->displaytag .*/ "New Task: " . $this->task->title . "\n\n";
        $msg .= $this->task->preface_text . "\n\n";
        $msg .= "This new task was posted by " . $this->task->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $msg .= "Description: ".$this->task->description."\n\n";
        $msg .= "Priority Rating: ".$this->task->translatePriority($this->task->priority)." | Category: " .$this->task->category."\n\n";
        $msg .= "View it at: ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->task->marea_id;
        $msg .= "&msg_id=".$this->task->msg_id;
        $this->emailNotify( $this->task->author, $emailSubj, $msg,
                            $this->task->msg_id,
                            $this->task->marea_id);
  }
}


    
/******************************************
class LinkNotice extends Notice {
    function LinkNotice($db,$marea_id,$title,$preface,$link,$author,$msg_id) {
        $this->msg_id = $msg_id;
        $this->marea_name = $db->getOne("SELECT long_name FROM mareas WHERE
            marea_id = $marea_id");
        $this->author = $author;
        $this->title = $title;
	$this->preface = $preface;
	$this->link = $link;
        $this->marea_id = $marea_id;
    }

    function notify() {
        global $CURGROUP;
        $emailFrom = "";
        $emailSubj  = "New link \"".$this->title."\"";
        $emailSubj .= " by ".$this->author;
	
	$msg = $this->title . "\n\n";
	$msg .= $this->preface . "\n\n";
	$msg .= "Link: " . $this->link . "\n\n";
        $msg .= "This new discussion item posted by " . $this->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $msg .= "View it at:  ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->marea_id;
        $msg .= "&msg_id=".$this->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}******************************************/

class LinkNotice extends Notice {
  function LinkNotice($db, $link) {
    $this->link = $link;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas WHERE
            marea_id = $link->marea_id");
  }

    function notify() {
        global $CURGROUP;
        $emailSubj  = "New link \"".$this->link->title."\"";
        $emailSubj .= " by ".$this->link->author;
	
        $msg = $this->link->display_tag . ". " . $this->link->title . "\n\n";
        $msg .= $this->link->preface_text . "\n\n";
        $msg .= "Link: " . $this->link->link . "\n\n";
        $msg .= "This new link was posted by " . $this->link->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $msg .= "View it at:  ";
        $msg .= $CURGROUP->getUrlRoot()."/marea/?";
        $msg .= "marea_id=".$this->link->marea_id;
        $msg .= "&msg_id=".$this->link->msg_id;
        $this->emailNotify( $this->link->author, $emailSubj, $msg,
                            $this->link->msg_id, $this->link->marea_id);
    }
}

// NOTE: nowhere uses this Notice right now......
class MeetingAreaNotice extends Notice {
    function MeetingAreaNotice($name, $creator, $marea_id) {
        $this->name = $name;
        $this->creator = $creator;
        $this->marea_id = $marea_id;
    }
    function notify() {
        global $CURGROUP;
        $emailSubj  = "New meeting area \"".$this->name."\"";
        $emailSubj .= " by ".$this->creator;

        $emsg  = $this->creator." has created the meeting area ";
        $emsg .= "\"".$this->name."\".\n\n";
        $emsg .= "View at:\n";
        $emsg .= "  ".$CURGROUP->getUrlRoot()."/marea/?marea_id=".$this->marea_id;

        $this->emailNotify($this->creator, $emailSubj, $emsg,
                           0, //msg_id ? XXX
                           $this->marea_id);
    }
}

// XXX need to pass in more info!!!!!!  maybe just the $poll
class AnnounceCloseNotice extends Notice {
    function notify(&$poll, $subj, $body) {
        $this->emailNotify("", $subj, $body,
                           $poll->closer_msg_id,
                           $poll->marea_id,
                           "Deme Poll Closer <no_reply@groupspace.org>");
    }
}


class PollNotice extends Notice {
    function PollNotice($poll, $db) {
        $this->poll = $poll;
        $q = "SELECT long_name FROM mareas
              WHERE marea_id = ".$this->poll->marea_id;
        $this->marea_name = $db->getOne($q);
    }

    function notify() {
        global $CURGROUP;
        $emailSubj  = "New Poll: \"".$this->poll->title."\"";
//        $emailSubj .= " created by ".$this->poll->author;
	
        $emsg = $this->poll->display_tag . ". " . $this->poll->title . "\n\n";
        $emsg .= $this->poll->author ." has created a new poll ";
        $emsg .= "in the meeting area \"".$this->marea_name."\".\n";
        $emsg .= "View at: ";
        $emsg .= $CURGROUP->getUrlRoot()."/marea/?";
        $emsg .= "marea_id=".$this->poll->marea_id;
        $emsg .= "&obj_id=".$this->poll->poll_id;
        $emsg .= "&obj_type=poll";
        $this->emailNotify( $this->poll->author, $emailSubj, $emsg,
                            $this->poll->orig_preface_msg_id,
                            $this->poll->marea_id);
    }
}
