<?

/* This file must be the FIRST INCLUDE of EVERY .php file. *
 * Except for .inc.php and lib/*.php 
 */


if( ! file_exists("../offweb/conf.php") ) {
    trigger_error("common.php can't find the configuration file.");
    trigger_error("Make sure ../offweb/conf.php exists, relative to current dir: ".getcwd());
    exit;
}
require_once "../offweb/conf.php";

/* More globals stuff stuck into conf. */

$CONF["IMAGES"] = $CONF['DEME_URL_ROOT'] ."/images";
//printr($CONF);


/*  kill /usr/share/pear so we're not accidentally having outside deps  */
ini_set("include_path", "");

//This is constant is deprecated.  Please use ../lib instead.
define("LIB", "../lib");

//Set umask to be the inverse of DEFAULT_MODE, just in case we ever start
//slinging around php functions or shell commands that respect the umask.
umask( 0777 ^ $CONF['DEFAULT_MODE'] );
define("DEME_VERSION", "0.5.0"); //DISTPREPARE: update version number!

//Constants for programmatic use.
define("ABSTAIN_PROP_ID", "-1");
define("GENERAL_SECTION_LOCATION", "-123");

/* ----------- headers for most Deme webpages. --------------- */

//API: set the NO_HEADERS variable first, then don't send this header stuff
if(!isset($NO_HEADERS)) {
    if(!isset($NO_CACHE_STUFF)) {
        header("Cache-Control: no-cache, must-revalidate");
        header("Pragma: no-cache");
        header("Expires: -1");
    }
    
    //All Deme pages are forced utf-8 for now.
    header("Content-Type: text/html; charset=utf-8");
}
 

/* ---- good functions to have around ---- */

function fatalPageError($errstring)
{
    error_log("Page error: $errstring");
    if(debug_mode()) {
        echo nl2br("Page error: " . $errstring) . "<br>";
    } else {
        header("Status: 500 Internal Server Error");
        echo "Sorry, an error occurred.";
        
    }
    exit();

}

/* ---- debugging -- */
function debug_mode() {
    global $CONF, $CURGROUP;
    $curgroup_allow = isset($CURGROUP) ? $CURGROUP->getConfigOption('debug') : false;
    return $CONF['DEBUG_MODE'] || $curgroup_allow;
}


//These are like the PHP var_dump and print_r, except they embed into html
//better and are easier to type :)

function vardump(&$var)
{
    if(!debug_mode()) return;
    echo "<PRE>\n";
    var_dump($var);
    echo "</pre>\n";
}
function printr(&$var)
{
    if(!debug_mode()) return;
    echo "<PRE>\n";
    print_r($var);
    echo "</pre>\n";
}
//just like printr except without pass by ref
//which php disallows for string constants (?!??!)
function debugprint($var)
{
    printr($var);
}
function dumpreq()
{
    global $CONF;
    if(!debug_mode()) return;
    echo "<PRE>\n";
    echo "--- GET ---\n";
    print_r($_GET);
    echo "--- POST ---\n";
    print_r($_POST);
    echo "--- COOKIE ---\n";
    print_r($_COOKIE);
    echo "----- SESSION: ----\n";
    if(!isset($_SESSION)) {echo "no session.<BR>";}
    else {print_r($_SESSION);}
    echo "</pre>\n";
}

    
?>
