<?
// Useful functions for dealing with messages.

//function new_msg($db, $subj, $msgtext, $marea_id,
//                 $in_reply_to,  $author, $primary_ref_id)
//{
//    $new_msg_id = new_msg_in_db($db,
//                                $subj, $msgtext, $marea_id,
//                                $in_reply_to, $author, $primary_ref_id);
//    new_msg_email($db, $subj, $msgtext, $marea_id,
//                  $in_reply_to, $author, $primary_ref_id);
//    return $new_msg_id;
//}


//is this misguided?  seems to conflict with the Notices system.
// function new_msg_email($db, $subj, $msgtext, $marea_id,
//                        $in_reply_to, $author, $primary_ref_id)
// {
//     debugprint("new_msg_email START");
// }

//If you're giving an in_reply_to, you should give 0 for primary_ref_id
//and this function will figure it out (primary_ref_id is always inherited
//from the parent - a rule enforced by this function.)
function new_msg_in_db($db, $subj, $msgtext, $marea_id,
                 $in_reply_to,  $author, $primary_ref_id)
{
    
    //Locking to avoid race conditions on multiple bits of information 
    //being inserted into all these different tables.

    //We have to lock ALL tables that are gonna get used until the UNLOCK TABLES
    //even groupopts, though we don't care about safety on that one.

    //Note for development: you can only do an UNLOCK TABLES from the same
    //thread that did the LOCK TABLES, so if during debugging things get locked
    //up and you can't unlock it, the only way i know to solve is the clunky
    // "/etc/init,d/mysqld restart".

    $db->query("LOCK TABLES msgs WRITE,
                            refs WRITE,
                            folio_items WRITE,
                            tags WRITE,
                            docs WRITE,
                            files WRITE,
                            groupopts WRITE");
    $db->setErrorHandling(PEAR_ERROR_CALLBACK, "error_callback_whenlocked");
    
    if($in_reply_to) {
        $find_replied_to_q =
            "SELECT msg_id, thread_depth, primary_ref_id
                      FROM msgs
                      WHERE msg_id = ".$in_reply_to;

        $replied_to_msg = $db->getRow($find_replied_to_q);
        
        $thread_depth = $replied_to_msg['thread_depth'] + 1;
        $primary_ref_id = $replied_to_msg['primary_ref_id'];

    } else {
         $thread_depth = 0;
//          //holdover from post-main.php
//          if (isset($_REQUEST['ref_loc'])){
//              $primary_ref_id = create_new_ref($db, $_REQUEST['ref_loc'], $_REQUEST['obj_id'], $_REQUEST['obj_type'], true);
//              //Remember, create_new_ref still needs finish_up_new_ref later
//          } else {
//              $primary_ref_id = 0;
//          }
    }

    $msg_insert_query  = "INSERT msgs SET 
        subj           = '".addslashes($subj)."',
        msgtext        = '".addslashes($msgtext)."',
        discoowner_id  = ".$marea_id.",
        in_reply_to    = ".$in_reply_to.",
        when_posted    = NOW(),
        thread_depth   = ".$thread_depth.",
        author         = '".addslashes($author)."',
        primary_ref_id = $primary_ref_id,
        num_replies    = 0";
    
    debugprint( ($msg_insert_query) . "\n<BR>");

    $db->query($msg_insert_query);

    $inserted_msg_id = $db->getOne("SELECT LAST_INSERT_ID()");

    //holdover from post-main.php
//     //----- other stuff
//     if(!$_REQUEST['in_reply_to'] && isset($_REQUEST['ref_loc'])) {
//         finish_up_new_ref($db, $primary_ref_id, $inserted_msg_id);
//     } else {
//     }

    
    // num_replies updating: query up the tree
    //      could have 1 less query by writing out the loop-and-a-half
    //      to hard-set in_reply_to from $_REQUEST instead of querying for
    //      it.....
    while($in_reply_to != 0) {
        $q = "UPDATE msgs SET num_replies = num_replies+1
              WHERE msg_id = $in_reply_to";
        debugprint( $q );
        $db->query($q);
      
        $q = "SELECT in_reply_to FROM msgs WHERE msg_id = $in_reply_to";
        debugprint( $q );
        $in_reply_to = $db->getOne($q);
    }
    

    $db->query("UNLOCK TABLES");
    $db->setErrorHandling(PEAR_ERROR_CALLBACK, "dbinit_error_callback");
        
    return $inserted_msg_id;
}