<?php


// main.php: The Group Home Page.

//Note.  This file is accessed via http://url_root/ -- no main/ prefix.
//THe php environment has been chdir()'d so php serverside pathnames work as
//expected from out of main/.  But client-visible stuff, like URL's and links,
//need to be relative to url_root instead.

require_once "../lib/common.php";

require_once "../lib/DemeAuth.php";
require_once "../lib/dateutil.php";
require "../meta/deme-bridge.php";
$db = $CURGROUP->getDB();

$a = new DemeAuth();
$allowNotLoggedIn = $CURGROUP->getConfigOption('allow_guest_on_grouphome') && !(isset($_REQUEST['forcelogin']) && $_REQUEST['forcelogin']);
$allowGroupGuest  = !(isset($_REQUEST['forcejoin']) && $_REQUEST['forcejoin']);
$a->start($allowNotLoggedIn, $allowGroupGuest, false);

//so we don't have a silly '?forcelogin=1' hanging out there, once loggedin...
if($_SERVER['QUERY_STRING'] == 'forcelogin=1' && $a->getAuth()) {
    //XXX should convert to a centralized getThisPagesUrl() function
    //instead of arbitrarily choosing SCRIPT_NAME or PHP_SELF or whatnot
    $url = dirname($_SERVER['SCRIPT_NAME']);
    header("Location: $url");
    exit;
}

$sandbox = $CURGROUP->getConfigOption('sandbox');
if($sandbox && $a->getUsername() == 'guest') {
    //we don't want to be logged in as the guest account; rather, group homepage
    //is supposed to have a null login, the UI calls "guest".
    //should only be logged in as 'guest' for places that require a user,
    //like mareas.
    $a->logout();
}


//dump_req();
?>

<HTML>
<HEAD><TITLE><?=htmlspecialchars($CURGROUP->getLongName())?></TITLE>
<link rel="stylesheet" href="main/home.css.php" type="text/css">
<link rel="stylesheet" href="marea/ws.css.php" type="text/css">

</head>

<body>
<div class="loginbox" align="right">
<?

printLoginRegisterBox();


?>
</div>
<?
// echo "<div align=left>"; dumpreq(); echo "</div>";
?>
<div id="content-container">
<!-- <div id="top"><span class="title">DEME</span><br />version is <?=DEME_VERSION?> </div> -->

<script>
<?// --------- print a browser warning message. -------------?>

function sadtext(browsername) {
    text = "Sorry, you seem to be using the "+browsername+" web browser, which doesn't support all the features of POD.  You can use it a little, but won't be able to do the really interesting things.";
    text += "Please see the Deme homepage for information for how to get the right browser.  <a href=http://www.groupspace.org>http://www.groupspace.org</a>";
    text += "<P>But of course, if things work fine for you, drop us an email saying so, so we can get rid of this message for you!";
    document.write("<BR><BR><div style=\"border:5px red solid; padding:5px;\">"+text+"</div><BR><BR>");
}

//if(navigator.userAgent.search('Safari') != -1) 
//    sadtext("Safari");
//else
if(navigator.userAgent.search('MSIE.*Mac') != -1) 
    sadtext("Macintosh Internet Explorer");
else if(navigator.userAgent.search('KHTML') != -1 &&
        navigator.userAgent.search('Safari') == -1)
    sadtext("a KHTML-derived browser (such as linux Konqueror)");

</script>

<?//  ------------------- top of page now ------------------- ?>
<div id="top"><span class="groupname"><?=htmlspecialchars($CURGROUP->getLongName());?></span></div>

<? if(!$a->getAuth()) { ?>
    <div id="guestwarn">You are not logged in, viewing as a guest.

    <?if(!$sandbox) { ?>
        <a href=.?forcelogin=1>Log in</a>
    <? } else { ?>
        In this group, you don't need to log in to use Deme.
        <P>But if you'd
        like, you can create an account for yourself anyways then
        <a href=.?forcelogin=1>log in</a>
    <? } ?>
    </div>
<? } ?>

    

<div id=warning> 
DEME version is <?=DEME_VERSION?>
<BR>
</div><div id="main-container"><div id="main">
<?
$summaryFile = $CURGROUP->getDataDir()."/summary.inc";
if (!file_exists($summaryFile)) {
    $fp = fopen($summaryFile, 'w');
    fwrite($fp, "Welcome to Deme!  Replace this message with a ".
           "brief description of this group by clicking on the ".
           "link below.");
    fclose($fp);
}
include $summaryFile;
?>
<BR>
<a class=editopt href=main/editsummary.php>[Edit this summary]</a>
<BR><BR>
<HR>
<?
if ($a->getAuth()) {
    echo "Welcome, <b> ".$a->getUsername()."<b>";

    $usersettings = $CONF['DEME_URL_ROOT'] . "/meta/usersettings.php?mode=group&group=".$CURGROUP->getName();
    $logouturl = $CONF['DEME_URL_ROOT']."/meta/logout.php?group=".$CURGROUP->getName();
                        
    echo "&nbsp;&nbsp; :::<a href=\"$usersettings\">my settings</a>";
    echo "&nbsp;&nbsp; :::<a href=\"$logouturl\">logout</a>";
    echo "&nbsp;&nbsp; :::<a href=\"".$CONF['DEME_URL_ROOT']."\">my groups</a>";
}
?>
<hr>
<table>
<tr><td valign=top align=left> <!-- column #1 -->
<table width=100% align=left">
<TR><td style="background:#e0e0f0; padding:10px;">
<h2>Meeting Areas</h2>
<div id="subgroups-items">
<?
if( !$a->getMembershipInGroup() && !$sandbox) {
    echo "You cannot view meeting areas unless you are a member of the group.";

    if($a->getAuth()) { 
        echo "<P><a href=.?forcejoin=1>Click here to <b>join</b></a> this group.";
    } else {
        echo "<P><a href=.?forcejoin=1>Click here to <b>login</b> and <b>join</b></a>.";
    }
} else {
    if ($sandbox && !$a->getAuth()) { 
        echo "You may view and enter meeting areas as an unregistered guest.";
    }

//Display all the meeting areas
    echo "<UL>";

    $q = "SELECT marea_id, long_name FROM mareas";
    $result = $db->query($q);
    while( $row = $result->fetchRow() ) {
        echo "<LI><a href=\"marea/?marea_id=$row[marea_id]\">$row[long_name]</a>";
    }
    echo "</ul>";
    echo "<p><a href=main/newmarea.php>Create new meeting area...</a>";
}
echo "</div>";
echo "</td></tr>";
echo "</table>";
//column #2
echo "<td valign=top width=\"50%\" id=\"centercontent\" style=\"padding-top: 10pt;\">";
echo "<h1>Announcements</h1>";
echo "<ul>";

// -------------------------- announcements ----------------------------

$q = "SELECT * FROM anns ORDER BY when_posted DESC  LIMIT 10";
$anns = $db->getAll($q);
foreach($anns as $ann) {
    echo "<LI>";
    $dt = mysql_timestamp_to_timestamp($ann['when_posted']);
    echo date("M-d",$dt);
    echo ": ";
    echo $ann['text'];
}
?>
</ul>
<a href=main/viewann.php>View all announcements</a><BR>
<a class=editopt href=main/newann.php>Add new announcement</a><BR>
</td>
          
<td valign=top valign=right> <!-- column #3 -->

<?// ---------------------- user options box -------------------?>
<table><TR><td style="background:#CFC; padding:10px;">
<h2>General Options</h2>
<UL>
<?if(!$a->getAuth()) { ?>

<? // XXX hardcode "http" is BAD because could be https.  SHOULD make general function in common.php to create URL of current page!!!!!!!!!!!!!!!!!!! some other places in the code use PHP_SELF, SCRIPT_NAME but I don't htink that's right either...?   ?>

<li><a href="<?=$CONF['DEME_URL_ROOT']."/meta/newuser.php?mode=group&group=".$CURGROUP->getName()."&redirect=".urlencode('http://'.$_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'])?>">Register</a> 
<? } ?>

<?if($a->getMembershipInGroup()) { ?>
  <li><a href=<?=$CONF['DEME_URL_ROOT']."/meta/usersettings.php?mode=meta"?>>My profile</a>

<? } else { ?>
  <li><a href=.?forcejoin=1>Join this group</a>
<? } ?>

<?if($a->getMembershipInGroup() || ($sandbox && !$a->getAuth())) { ?>
<li><a href="main/userlist.php">Member List</a>
<? } ?>

<li class=grayed>Calendar
<li><a href=main/links.php>Links</a>
<li><a href="main/library.php">Library</a>

<? if($a->getAuth() && $a->isGroupOwner($CURGROUP->getName())) { ?>
<li><a href="main/bulksubscribe.php">Bulk subscribe</a>
<? } ?>

<? if($a->getAuth() && $a->isGroupOwner($CURGROUP->getName())) { ?>
<li><a href="main/ownerprefs.php">Owner's Settings</a> <!--'-->
<? } ?>

<li class=grayed>FAQ (Frequently Asked Questions)
<li class=grayed>Search
<li class=grayed>Chat

<?  if(!$sandbox || ($a->getAuth() && $a->getUsername() != 'guest')) { ?>
<li><a href="main/leavegroup.php">Leave this group</a>
<?  } ?>

<!-- <li>Documents -->
<!-- <ul> -->
<!-- <li>Adopted Proposals -->
<!-- <li>General policies -->
<!-- </ul> -->
</UL>
</td></tr>
</table>

</table>
</td></tr>
</div> 

<?/* this clause doesn't exist yet.  it may in future versions of the pod
   * license.  it would look something like this:
   *
   * [start potential warning]
   * NOTE to administrators/developers: clause XXX of the Deme license
   * requires that the footer informing the user that they're using Deme
   * software may not be removed.
   * [end of potential warning]
   */
?>
 
<div id="footer">This site uses <a href=http://www.groupspace.org/>DEME</a> software.
</div>



</body></html>
