<?php

/* This page appears in this way:
 * (1) loaded in the 100%-sized frame of the popped-open post-popup.php.
 * and does all the actual work of posting.
 *
 * and it USED to be, this file also supported being
 * (2) loaded in the curmsg frame of the 4-pane mtg area view.
 *
 * Either way, the parent "caller" should initially pass all important variables
 * via GET.
 */

require_once "../lib/common.php";
require_once "../lib/Document.php";
require_once "../lib/DemeAuth.php";
require_once "../lib/msg.php";



//-- Transmitting... we need to pass on certain key/value pairs that
// are received here, in case if the form needs to be reentered.
// these will be HIDDEN variables.  $defaults is for VISIBLE, user-editable
// variables!

// discoowner_id is a very old name for the marea_id ("discussion owner") it
// should be refactored away once someone is brave enough to change its
// database schema entries as well.

$varnames_to_transmit = array(
    'in_reply_to', 'discoowner_id', 'ref_loc', 'obj_id', 'inpopup');

$defaults = array(
    'subj'    => "",
    'msgtext' => "");




$vars_to_transmit = array();
foreach( $varnames_to_transmit as $k => $var) {
    if(!isset($_REQUEST[$var])) {
        //die("No  to-be-transmitted '$var' in REQUEST!<BR>");
    } else {
        $vars_to_transmit[$var] = $_REQUEST[$var];
    }
}

function make_hidden_transmitter($assoc_array)
// The output of this goes into a <FORM> field.
{
    $s = "";
    foreach($assoc_array as $k => $v) {
        $s .= ' <input type=hidden ';
        $s .=        ' name ="' .$k. '"';
        $s .=        ' value="' .$v. '">';
    }
    return $s;
}

function make_form($defaults, $vars_to_transmit)
{
    global $auth;
    
    $s =    "<script>            
function handleEnter (field, event) {
	var keyCode = event.keyCode ? event.keyCode
                                : event.which ? event.which
                                              : event.charCode;
	if (keyCode == 13) {
		var i;
		for (i = 0; i < field.form.elements.length; i++)
			if (field == field.form.elements[i])
				break;
		i = (i + 1) % field.form.elements.length;
		field.form.elements[i].focus();
		return false;
	} 
	else {return true;}
}</script>";

    $s .= '
    <form method=POST>
    
    <P>Author: ' . $auth->getUsername() .'

    <P>Subject:
    <input type=text    name="subj" id="subj_input"
        value="' .$defaults['subj']. '"
        onKeyPress="return handleEnter(this,event)">

    <P><BR>
    <textarea  name="msgtext" class=msgtext
        rows=20 cols=65
        style="width:100%;  "
        wrap="virtual"
    >' .$defaults['msgtext']. '</textarea>

' . make_hidden_transmitter($vars_to_transmit) . '

    <input  type=submit 
            name="submit"  value="Post This Comment">
    </form>

';

    return $s;
}


// XXX generalize this to all obj_id/type
function create_new_ref($db, $ref_loc, $obj_id, $obj_type, $modRefHack)
{
    $old_obj_id = $obj_id;
    if (debug_mode()) echo " $ref_loc $obj_id $obj_type $modRefHack";
    if ($modRefHack) {
        $q = "SELECT item_id FROM folio_items WHERE 
            indiv_type_id = $obj_id AND type_id = 1";
        $obj_id = $db->getOne($q);
    }
    //    $db->query("LOCK TABLES refs WRITE");     // should be locked beforehand.  keep commented out!!!
    
    $q="";
    
    //Doesn't update referrer_id/type !!!!  call finish_up_ref() for that
    /* if($ref_loc == GENERAL_SECTION_LOCATION) $q = "INSERT refs SET
            referrent_id = $obj_id,
            referrent_type = 'doc' ";
    else
      {
	$refe_id = $db->getOne("SELECT ref_id FROM folio_items WHERE item_id = $obj_id");
	$q = "INSERT refs SET referrent_id = $refe_id, referrent_type = 'doc'";
      }   <<<< My additions are now commented out, but might be necessary to fix this NASTY bug.... -Andrew*/
    
    $q = "INSERT refs SET
            referrent_id = $obj_id,
            referrent_type = 'doc' ";
    if($ref_loc == GENERAL_SECTION_LOCATION)
        $q .= ", notes='general_comment' ";
    $db->query($q);
    $new_ref_id = $db->getOne("SELECT LAST_INSERT_ID()");
    $obj_id = $old_obj_id;
    
    if(debug_mode()) echo "ref_loc: $ref_loc <BR>";
    
    if($ref_loc != GENERAL_SECTION_LOCATION) {
        $doc = fetchDocumentFromDB($db, $obj_id);
        $doc->fillFromDB($db, $obj_id);
        $doc->readRawText();
        $doc->insertNewDocref($ref_loc, $new_ref_id);
        $doc->storeText();
    }
    
    return $new_ref_id;
}

function finish_up_new_ref($db, $ref_id, $using_msgowner_id)
{
    $db->query("UPDATE refs
                SET referrer_id   = $using_msgowner_id,
                    referrer_type = 'msg'
                WHERE ref_id = $ref_id");
}


///////////// currently being refactored into lib/msg.php's new_msg_in_db()

// function enter_msg_into_db($db)
// // Call this only once you're sure _REQUEST has the right stuff in it
// {
//     global $auth;
//     dumpreq();
    
    
//     //Locking to avoid race conditions on multiple bits of information 
//     //being inserted into all these different tables.

//     //We have to lock ALL tables that are gonna get used until the UNLOCK TABLES
//     //even groupopts, though we don't care about safety on that one.

//     //Note for development: you can only do an UNLOCK TABLES from the same
//     //thread that did the LOCK TABLES, so if during debugging things get locked
//     //up and you can't unlock it, the only way i know to solve is the clunky
//     // /etc/init,d/mysqld restart.

//     $db->query("LOCK TABLES msgs WRITE,
//                             refs WRITE,
//                             folio_items WRITE,
//                             tags WRITE,
//                             docs WRITE,
//                             files WRITE,
//                             groupopts WRITE");
//     $db->setErrorHandling(PEAR_ERROR_CALLBACK, "error_callback_whenlocked");
    
//     if( $_REQUEST['in_reply_to'] ) {
//         $find_replied_to_q =
//             "SELECT msg_id, thread_depth, primary_ref_id
//                       FROM msgs
//                       WHERE msg_id = ".$_REQUEST['in_reply_to'];

//         $replied_to_msg = $db->getRow($find_replied_to_q);
        
//         $thread_depth = $replied_to_msg['thread_depth'] + 1;
//         $primary_ref_id = $replied_to_msg['primary_ref_id'];

//     } else {
//          $thread_depth = 0;
//          if (isset($_REQUEST['ref_loc'])){
// 	   $primary_ref_id = create_new_ref($db, $_REQUEST['ref_loc'], $_REQUEST['obj_id'], $_REQUEST['obj_type'], true);
// 	   //Remember, create_new_ref still needs finish_up_new_ref later
//          } else {
//              $primary_ref_id = 0;
//          }
//     }

//     if ($_REQUEST['subj'] == "") {
//         if ($_REQUEST['in_reply_to'] == 0) {
//             $_REQUEST['subj'] = "No subject";
//         } else {
//             $parsubj = $db->getOne("SELECT subj FROM msgs WHERE msg_id = $_REQUEST[in_reply_to]");
//             $_REQUEST['subj'] = "Re: ".addslashes($parsubj);
//         }
//     }

//     //---- finally, the insertion query ----

// //     $insert_query  = "INSERT msgs VALUES ( "

// //      . "null, "  //msg_id autoincrements
// //      . "'" . $_REQUEST['subj']     . "' , "
// //      . "'" . $_REQUEST['msgtext']  . "' , "
// //      . $_REQUEST['discoowner_id']  . " , "
// //      . $_REQUEST['in_reply_to']    . " , "
// //      . "NOW()  , "
// //      . $thread_depth . " , "
// //      . "'" . $auth->getUsername()   . "' , "
// //      . $primary_ref_id . " , "
// //      . "0" .   " )"   ;
//     $msg_insert_query  = "INSERT msgs SET 
//         subj           = '".$_REQUEST['subj']."',
//         msgtext        = '".$_REQUEST['msgtext']."',
//         discoowner_id  = ".$_REQUEST['discoowner_id'].",
//         in_reply_to    = ".$_REQUEST['in_reply_to'].",
//         when_posted    = NOW(),
//         thread_depth   = ".$thread_depth.",,
//         author         = '".addslashes($auth->getUsername())."',
//         primary_ref_id = $primary_ref_id,
//         num_replies    = 0";

//     $_ = nl2br($insert_query) . "\n<BR>";
//     printr( $_ );

//     $db->query($msg_insert_query);

//     $inserted_msg_id = $db->getOne("SELECT LAST_INSERT_ID()");

//     //----- other stuff

//     if(!$_REQUEST['in_reply_to'] && isset($_REQUEST['ref_loc'])) {
//         finish_up_new_ref($db, $primary_ref_id, $inserted_msg_id);
//     } else {
//     }

//     // num_replies updating: query up the tree
//     //     XXX could have 1 less query by writing out the loop-and-a-half
//     //         to hard-set in_reply_to from $_REQUEST instead of querying for
//     //         it.....
//     $in_reply_to = $_REQUEST['in_reply_to'];
//     while($in_reply_to != 0) {
//         $q = "UPDATE msgs SET num_replies = num_replies+1
//               WHERE msg_id = $in_reply_to";
//         echo $q . "<BR>";
//         $db->query($q);
      
//         $q = "SELECT in_reply_to FROM msgs WHERE msg_id = $in_reply_to";
//         echo $q . '<BR>';
//         $in_reply_to = $db->getOne($q);
//     }
        

//     $db->query("UNLOCK TABLES");
//     $db->setErrorHandling(PEAR_ERROR_CALLBACK, "dbinit_error_callback");
        
//     return $inserted_msg_id;

// } //end update_db function


function footer_and_exit()
{
//     print "<PRE> Request:\n";
//     print_r($_REQUEST);
//     print "</pre>";

    echo "</body></html>";
    exit;
}

?>
<?

if(!isset($_REQUEST['discoowner_id'])) {
    die("Error, no discoowner_id passed");
}
$auth = new DemeAuth();
$auth->start();
if (!$auth->getMembership($_REQUEST['discoowner_id'])) {
    //a non-member shouldnt even be allowed to get this far!!!
    die("You can't post to this discussion.");
}
?>


<HTML>
<HEAD>
<style>
@import url(marea.css.php);
.msgtext {
 font-family: Verdana, Arial, sans-serif;
}    
body {
    background: #eef;
}

.
</style>


</HEAD>


<BODY
onLoad="var e=document.getElementById('subj_input'); if(e){e.focus();}"
>

<div id=warning_area></div>
<?php



if (isset($_POST['submit'])) {
    $db = $CURGROUP->getDB();

    //--- case: bad post, they have to compose again
    //TODO: more bad-posting conditions, ws-discarding regexes?
    //TODO: this should be handled by JS to save a form submit or two
    if (//$_REQUEST['msgtext'] == $defaults['msgtext'] ||
        //$_REQUEST['msgtext'] == ""
        false) {

        echo '<P><span style="color: red;">';
        echo 'Please Enter A Message in the ';
        echo 'compositon box.</span>';

        //--- fill back in the values they've already written.
        foreach($defaults as $key => $value) {
            if (isset($_REQUEST[$key])) {
                $defaults[$key] = $_POST[$key];
            }
        }
    } else {
        //We have a POST submission containing a new message. now do stuff!
        if ($_REQUEST['msgtext'] == "") {
            $_REQUEST['msgtext'] = '(no text)';
        }

        //XXX need the ref_loc stuff
        if (isset($_REQUEST['ref_loc'])){
            $primary_ref_id = create_new_ref($db, $_REQUEST['ref_loc'], $_REQUEST['obj_id'], $_REQUEST['obj_type'], true);
            //Remember, create_new_ref still needs finish_up_new_ref later
        } else {
            $primary_ref_id = 0;
        }

        //XXX solve empty subject here.
        if (!isset($_REQUEST['subj']) || $_REQUEST['subj'] == "") {
            if ($_REQUEST['in_reply_to'] == 0) {
                $_REQUEST['subj'] = "No subject";
            } else {
                $parsubj = $db->getOne("SELECT subj FROM msgs WHERE msg_id = $_REQUEST[in_reply_to]");
                if(! preg_match('/^Re: /', $parsubj))
                    $_REQUEST['subj'] = "Re: ".addslashes($parsubj);
            }
        }
        
        $new_msg_id = new_msg_in_db($db,
                              stripslashes($_REQUEST['subj']),
                              stripslashes($_REQUEST['msgtext']),
                              ($_REQUEST['discoowner_id']),
                              ($_REQUEST['in_reply_to']),
                              $auth->getUsername(),
                              $primary_ref_id);
        debugprint("<B>new msg id  = $new_msg_id</b><BR>");

        if(!$_REQUEST['in_reply_to'] && isset($_REQUEST['ref_loc'])) {
            finish_up_new_ref($db, $primary_ref_id, $new_msg_id);
        }

        //reload the msglist & possibly folioview
        echo '<P>Your posting is complete! ';
        
        if($_REQUEST['inpopup']) {
            echo '<script>';
            echo "parent.finish($new_msg_id);";
            echo "</script>";
        } else {
            //XXX old code, doesn't get called anymore.  does it still work????
            echo "<script>";
            echo "alert('fixme in post-main at the XXX first');";
            echo "parent.frames.msglist.reload_and_hilite($new_msg_id);";
            //XXX update the folioview
            echo "window.location.replace(\"$msgurl\");";
            echo "</script>";
        }
        
        $marea_name = $db->getOne("SELECT long_name FROM mareas WHERE marea_id = $_REQUEST[discoowner_id]");
        
        echo "</body></html>";

        //---- now do backend-ish stuff ----
        $subj = stripslashes($_REQUEST['subj']);
        $emsg  = "Meeting area: \"$marea_name\"\n";
        $emsg .= "  ".$CURGROUP->getUrlRoot()."/marea/?marea_id=$_REQUEST[discoowner_id]&msg_id=$new_msg_id\n";
        $emsg .= "\n";
        $emsg .= $subj . "\n\n";
        $emsg .= stripslashes($_REQUEST['msgtext']);
	
        if($_REQUEST['in_reply_to']) {
            $in_reply_to = $_REQUEST['in_reply_to'];
            
            $reply_marks = "";

            /************
            while($in_reply_to != 0) {
                $reply_marks .= "//";
                $q = "SELECT * FROM msgs WHERE msg_id = " . $in_reply_to;
                $replied_msg = $db->getRow($q);
                $emsg .= "\n\n";
                $emsg .= $reply_marks . " " . $replied_msg["subj"] . "\n" . $reply_marks . "\n" . $reply_marks . " ";
                $emsg .= str_replace("\n", "\n" . $reply_marks . " ", $replied_msg["msgtext"]);
                $in_reply_to = $replied_msg["in_reply_to"];
            } ***********/
            //I moved this end comment marker to fix a bug that caused problems with posting 
            //new message.  Hopefully I can figure out what this commented out code was supposed to do.
	}
        
        if(isset($_REQUEST['ref_loc'])) {
            $ref_loc = $_REQUEST['ref_loc'];
            $obj_id = $_REQUEST['obj_id'];
            
            debugprint($ref_loc . "****");
            
            if($ref_loc != GENERAL_SECTION_LOCATION) {
                $doc = fetchDocumentFromDB($db, $obj_id);
                $doc->fillFromDB($db, $obj_id);
                $doc->readRawText();
                $comment_text = $doc->getCommentedText($ref_loc); //Andrew: I put this function back into Document.php cause it was missing...
                
                if($comment_text != "") {
                    $emsg .= "\n\n";
                    $emsg .= "Comment on: \"" . $comment_text . "\"";
                }
                debugprint(" ".$comment_text ."*****");
            }
        }
	    
        require_once "../lib/Notices.php";
        $n = new MessageNotice($auth->getUsername(),
                               $new_msg_id,
                               $_REQUEST['discoowner_id'],
                               $subj,
                               $emsg);
        echo "<HR>";
        
        $n->notify();
        
        exit;
    }
}
$db = $CURGROUP->getDB();

if($vars_to_transmit["in_reply_to"]) {
  $q = "SELECT msgtext FROM msgs WHERE msg_id = $vars_to_transmit[in_reply_to]";
  $defaults["msgtext"] = str_replace("\n", "\n:", $db->getOne($q));
  $q = "SELECT author, when_posted FROM msgs WHERE msg_id = $vars_to_transmit[in_reply_to]";
  $prevInfo = $db->getRow($q);
  $defaults["msgtext"] = "\n\n\n------ " . $prevInfo['author'] . 
    " wrote on: " . $prevInfo['when_posted'] . ".------\n:" . $defaults["msgtext"];
  /*$defaults["msgtext"] = str_replace("\n\n\n::", "\n\n\n::::", $db->getOne($q));
  $defaults["msgtext"] = "\n\n\n:: " . $defaults["msgtext"];*/
}
echo make_form($defaults, $vars_to_transmit);
footer_and_exit();

?>
