#!/usr/bin/php -q
<?
// $Id: dbapply.php 125 2005-05-05 03:28:35Z brendano $


$usage = "USAGE

This is a commandline script to apply one SQL query to all the group db's of
the installation.  Intended uses include mass reporting & mass schema changes.

 ./dbapply.php -h        to see this help message
 ./dbapply.php -l        to list group db's it'll operate on

STANDARD USAGE

one sql statement:
 echo \"SELECT subj FROM msgs WHERE author='bob'\"  | ./dbapply.php
 echo \"ALTER TABLE ...blablabla...\"  |  ./dbapply.php

a file of one or many sql statements:
 ./dbapply.php < manycommands.sql

You put the SQL on the standard input, and it runs it on every single
group DB for the installation that the meta db 'groups' table knows about.
        USE WITH CARE!!!!!!!  see comments inside for more notes
";


/*
 * If you're actually using this to MAKE CHANGES, you should make a file
 * with your sql commands, then test on a single group like so:
 *
 * $ mysql -uDBUSER -pDBPASS deme_testgrp  < manycommands.sql
 *
 * then when ready, go ahead and run manycommands.sql through dbapply.php.
 */


require_once "../lib/common.php";
require_once "../lib/dbinit.php";
require_once "../lib/Group.php";

// "Parse" commandline options
$listmode = $helpmode = false;
if( $_SERVER['argv'] && count($_SERVER['argv']) > 1 ) {
    $listmode = $_SERVER['argv'][1] == "-l";
    $helpmode = $_SERVER['argv'][1] == "-h" ||  $_SERVER['argv'][1] == '-?';
}

if($helpmode) {
    echo $usage;
    exit(-1);
}

// The SQL query we want to apply to all groups.
$sql = "";

if( !$listmode  ) {
    $fd = fopen("php://stdin", "r");
    while (!feof($fd)) {
        $sql.= fread($fd, 1024);
    }
    fclose($fd);
    
    if( (! $sql)) {
        echo "ERROR: you seem to have given an empty SQL query.\n";
        echo $usage;
        exit(-1);
    }
}



// Go through each group and run $sql

$metadb = dbinit_meta_connect();
$groupsres = $metadb->getAll("SELECT name FROM groups");

foreach($groupsres as $row) {
    $groupname = $row['name'];

    if( $listmode ) {
        echo $groupname . "\n";
        continue;
    }

    $group = Group::fetchGroupByName($metadb, $groupname);
    $db = $group->getDB();


    echo "*** RESULT FROM RUNNING QUERY ON GROUP \"$groupname\"\n";

    //Change for nicer looking reporting!
    $result = $db->getAll( $sql );
    print_r( $result );
}


?>
