-- MySQL dump 8.23
--
-- Host: localhost    Database: ben-svn_svn-branch
---------------------------------------------------------
-- Server version	3.23.58

--
-- Table structure for table `actions`
--

CREATE TABLE actions (
  action_id int(10) unsigned NOT NULL auto_increment,
  prop_id int(10) unsigned NOT NULL default '0',
  type varchar(50) NOT NULL default '',
  action_details mediumtext NOT NULL,
  PRIMARY KEY  (action_id),
  KEY prop_id (prop_id)
) TYPE=MyISAM;

--
-- Table structure for table `anns`
--

CREATE TABLE anns (
  id int(10) unsigned NOT NULL auto_increment,
  when_posted timestamp(14) NOT NULL,
  text mediumtext NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `categories`
--

CREATE TABLE categories (
  category_id int(10) NOT NULL auto_increment,
  category varchar(25) NOT NULL default 'default',
  proj_id int(10) NOT NULL default '0',
  PRIMARY KEY  (category_id)
) TYPE=MyISAM;

--
-- Table structure for table `discoitems`
--

CREATE TABLE discoitems (
  discoitem_id int(10) unsigned NOT NULL auto_increment,
  ref_id int(10) unsigned NOT NULL default '0',
  msg_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (discoitem_id)
) TYPE=MyISAM;

--
-- Table structure for table `docs`
--

CREATE TABLE docs (
  doc_id int(10) unsigned NOT NULL auto_increment,
  file_id int(10) unsigned NOT NULL default '0',
  doctype enum('plaintext','upload','dummy') NOT NULL default 'plaintext',
  parent_doc_id int(10) unsigned NOT NULL default '0',
  first_parent_doc_id int(10) unsigned NOT NULL default '0',
  subtag int(11) NOT NULL default '0',
  orig_author varchar(40) binary NOT NULL default '',
  orig_preface_ref_id int(10) unsigned NOT NULL default '0',
  orig_preface_msg_id int(10) unsigned NOT NULL default '0',
  filename varchar(255) binary NOT NULL default '',
  mimetype varchar(255) binary NOT NULL default 'text/plain',
  subdoc_of_id varchar(50) binary NOT NULL default '0',
  PRIMARY KEY  (doc_id)
) TYPE=MyISAM;

--
-- Table structure for table `files`
--

CREATE TABLE files (
  file_id int(10) unsigned NOT NULL auto_increment,
  when_created datetime NOT NULL default '0000-00-00 00:00:00',
  filetype enum('doc','genfile','pic') NOT NULL default 'doc',
  PRIMARY KEY  (file_id)
) TYPE=MyISAM;

--
-- Table structure for table `folio_items`
--

CREATE TABLE folio_items (
  item_id int(10) unsigned NOT NULL auto_increment,
  type_id int(10) unsigned NOT NULL default '0',
  indiv_type_id int(10) unsigned NOT NULL default '0',
  marea_id int(10) unsigned NOT NULL default '0',
  title varchar(50) NOT NULL default '',
  preface_text longtext NOT NULL,
  preface_last_update datetime NOT NULL default '0000-00-00 00:00:00',
  preface_last_update_by_username varchar(25) NOT NULL default '0',
  author varchar(25) NOT NULL default '',
  when_created datetime NOT NULL default '0000-00-00 00:00:00',
  ref_id int(10) unsigned NOT NULL default '0',
  msg_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (item_id)
) TYPE=MyISAM;

--
-- Table structure for table `genfiles`
--

CREATE TABLE genfiles (
  file_id int(10) unsigned NOT NULL default '0',
  filename varchar(255) binary NOT NULL default '',
  mimetype varchar(100) NOT NULL default '',
  PRIMARY KEY  (file_id)
) TYPE=MyISAM;

--
-- Table structure for table `groupopts`
--

CREATE TABLE groupopts (
  allow_guest_on_grouphome tinyint(1) NOT NULL default '1',
  sandbox tinyint(1) NOT NULL default '0',
  email_subj_prefix varchar(255) NOT NULL default '',
  debug tinyint(1) unsigned NOT NULL default '0'
) TYPE=MyISAM COMMENT='only one row!';

--
-- Table structure for table `handlers`
--

CREATE TABLE handlers (
  handler_id int(10) NOT NULL auto_increment,
  task_id int(10) NOT NULL default '0',
  handler varchar(40) NOT NULL default '',
  PRIMARY KEY  (handler_id)
) TYPE=MyISAM;

--
-- Table structure for table `hasreads`
--

CREATE TABLE hasreads (
  username varchar(40) binary NOT NULL default '',
  msg_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (username,msg_id)
) TYPE=MyISAM;

--
-- Table structure for table `links`
--

CREATE TABLE links (
  link_id int(10) unsigned NOT NULL auto_increment,
  link mediumtext NOT NULL,
  PRIMARY KEY  (link_id)
) TYPE=MyISAM;

--
-- Table structure for table `mareas`
--

CREATE TABLE mareas (
  marea_id int(10) unsigned NOT NULL auto_increment,
  short_name varchar(20) NOT NULL default '',
  long_name varchar(50) NOT NULL default '',
  owner_id int(10) unsigned NOT NULL default '1',
  perms_type enum('everyone','admittance') NOT NULL default 'everyone',
  when_created datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (marea_id)
) TYPE=MyISAM;

--
-- Table structure for table `msgs`
--

CREATE TABLE msgs (
  msg_id int(10) unsigned NOT NULL auto_increment,
  subj varchar(200) default NULL,
  msgtext longtext,
  discoowner_id int(10) unsigned NOT NULL default '0',
  in_reply_to int(10) unsigned NOT NULL default '0',
  when_posted datetime default NULL,
  thread_depth int(10) unsigned NOT NULL default '0',
  author varchar(40) binary default NULL,
  primary_ref_id int(10) unsigned default NULL,
  num_replies int(10) unsigned NOT NULL default '0',
  email_to text,
  email_cc text,
  email_from tinytext,
  email_raw longblob,
  PRIMARY KEY  (msg_id),
  KEY discoowner_id (discoowner_id)
) TYPE=MyISAM;

--
-- Table structure for table `nonuser_subscribers`
--

CREATE TABLE nonuser_subscribers (
  email varchar(255) NOT NULL default '',
  PRIMARY KEY  (email)
) TYPE=MyISAM;

--
-- Table structure for table `polls`
--

CREATE TABLE polls (
  poll_id int(10) unsigned NOT NULL auto_increment,
  when_closes datetime NOT NULL default '0000-00-00 00:00:00',
  is_open tinyint(3) unsigned NOT NULL default '1',
  orig_preface_msg_id int(10) unsigned NOT NULL default '0',
  orig_preface_ref_id int(10) unsigned NOT NULL default '0',
  closer_msg_id int(10) unsigned NOT NULL default '0',
  closer_ref_id int(10) unsigned NOT NULL default '0',
  drule mediumtext,
  tally mediumtext,
  method_type varchar(15) default NULL,
  drule_type varchar(15) default NULL,
  is_straw tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (poll_id)
) TYPE=MyISAM;

--
-- Table structure for table `projs`
--

CREATE TABLE projs (
  proj_id int(10) unsigned NOT NULL auto_increment,
  contains_deadline tinyint(1) NOT NULL default '0',
  deadline datetime NOT NULL default '0000-00-00 00:00:00',
  next_subtag varchar(10) NOT NULL default '.a',
  PRIMARY KEY  (proj_id)
) TYPE=MyISAM;

--
-- Table structure for table `props`
--

CREATE TABLE props (
  prop_id int(10) unsigned NOT NULL auto_increment,
  poll_id int(10) unsigned NOT NULL default '0',
  text mediumtext NOT NULL,
  PRIMARY KEY  (prop_id)
) TYPE=MyISAM;

--
-- Table structure for table `refs`
--

CREATE TABLE refs (
  ref_id int(10) unsigned NOT NULL auto_increment,
  referrer_type varchar(10) NOT NULL default 'notype',
  referrer_id int(10) unsigned NOT NULL default '0',
  referrent_type varchar(10) NOT NULL default 'notype',
  referrent_id int(10) unsigned NOT NULL default '0',
  notes varchar(60) NOT NULL default 'nonote',
  PRIMARY KEY  (ref_id),
  KEY referrer_type (referrer_type),
  KEY referrer_id (referrer_id),
  KEY referrent_type (referrent_type),
  KEY referrent_id (referrent_id)
) TYPE=MyISAM;

--
-- Table structure for table `tags`
--

CREATE TABLE tags (
  tag int(11) NOT NULL default '0',
  display_tag varchar(10) NOT NULL default '',
  item_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (item_id)
) TYPE=MyISAM;

--
-- Table structure for table `tasks`
--

CREATE TABLE tasks (
  task_id int(10) unsigned NOT NULL auto_increment,
  proj_id int(10) unsigned NOT NULL default '0',
  name varchar(40) NOT NULL default '',
  priority int(2) unsigned NOT NULL default '5',
  est_time datetime NOT NULL default '0000-00-00 00:00:00',
  category varchar(30) NOT NULL default '',
  status varchar(20) NOT NULL default '',
  lastchg datetime NOT NULL default '0000-00-00 00:00:00',
  history longtext NOT NULL,
  description longtext NOT NULL,
  duration float NOT NULL default '0',
  PRIMARY KEY  (task_id)
) TYPE=MyISAM;

--
-- Table structure for table `usermareas`
--

CREATE TABLE usermareas (
  username varchar(40) binary NOT NULL default '',
  marea_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (username,marea_id)
) TYPE=MyISAM;

--
-- Table structure for table `userpolls`
--

CREATE TABLE userpolls (
  username varchar(40) binary NOT NULL default '',
  poll_id int(10) unsigned NOT NULL default '0',
  when_voted datetime NOT NULL default '0000-00-00 00:00:00',
  msgtext mediumtext,
  method_type varchar(15) NOT NULL default '',
  vote_data mediumtext NOT NULL,
  PRIMARY KEY  (username,poll_id)
) TYPE=MyISAM;

--
-- Table structure for table `users`
--

CREATE TABLE users (
  username varchar(40) binary NOT NULL default '',
  wants_email_posts tinyint(1) NOT NULL default '1',
  wants_daily_digests tinyint(1) NOT NULL default '1',
  is_owner tinyint(1) NOT NULL default '0',
  default_proj_view varchar(30) NOT NULL default '11111111110011display_tag',
  PRIMARY KEY  (username)
) TYPE=MyISAM;

