-- MySQL dump 8.23
--
-- Host: localhost    Database: ben-svn_meta
---------------------------------------------------------
-- Server version	3.23.58

--
-- Table structure for table `groups`
--

CREATE TABLE groups (
  group_id int(10) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  long_name varchar(255) NOT NULL default '',
  invite_only tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (group_id)
) TYPE=MyISAM;

--
-- Table structure for table `guest_ip_log`
--

CREATE TABLE guest_ip_log (
  guest_ip_log_id int(10) unsigned NOT NULL auto_increment,
  ip varchar(40) binary NOT NULL default '',
  timestamp timestamp(14) NOT NULL,
  PRIMARY KEY  (guest_ip_log_id)
) TYPE=MyISAM;

--
-- Table structure for table `item_types`
--

CREATE TABLE item_types (
  type_id int(11) NOT NULL auto_increment,
  type_name varchar(20) NOT NULL default '',
  type_short_name varchar(10) NOT NULL default '',
  type_db_name varchar(30) NOT NULL default '',
  PRIMARY KEY  (type_id)
) TYPE=MyISAM;

--
-- Table structure for table `user_permissions`
--

CREATE TABLE user_permissions (
  username varchar(30) NOT NULL default '',
  groupname varchar(25) NOT NULL default '',
  meetingArea_id int(11) NOT NULL default '0',
  permission varchar(25) NOT NULL default '',
  wants_email_posts tinyint(4) NOT NULL default '1',
  wants_daily_digests tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (username,groupname,meetingArea_id)
) TYPE=MyISAM;

--
-- Table structure for table `users`
--

CREATE TABLE users (
  user_id int(10) unsigned NOT NULL auto_increment,
  username varchar(40) binary NOT NULL default '',
  password_md5 varchar(32) binary NOT NULL default '',
  email varchar(50) NOT NULL default '',
  firstname varchar(100) default NULL,
  lastname varchar(100) default NULL,
  usehelp tinyint(4) NOT NULL default '1',
  should_see_intro tinyint(4) NOT NULL default '1',
  is_admin tinyint(4) NOT NULL default '0',
  about_self text,
  homepage tinyblob,
  phone tinytext,
  picture mediumblob,
  address text,
  im_name text,
  PRIMARY KEY  (user_id)
) TYPE=MyISAM;

-- MySQL dump 8.23
--
-- Host: localhost    Database: ben-svn_meta
---------------------------------------------------------
-- Server version	3.23.58

--
-- Dumping data for table `item_types`
--


INSERT INTO item_types VALUES (1,'Document','doc','docs');
INSERT INTO item_types VALUES (2,'Discussion Item','discoitem','discoitems');
INSERT INTO item_types VALUES (3,'Link','link','links');
INSERT INTO item_types VALUES (4,'Decision','poll','polls');
INSERT INTO item_types VALUES (5,'Straw Poll','poll','polls');
INSERT INTO item_types VALUES (6,'Project','proj','projs');
INSERT INTO item_types VALUES (7,'Task','task','tasks');

